unit ComThrd;

interface

uses
  Main,
  Windows;

function PollThread(par: cardinal): cardinal; stdcall;
procedure PollThreadTerminate;
procedure PollThreadWaitFor;
procedure PollThreadCreate;

var
  hPollThread,PollThreadID: cardinal;

implementation

uses saa713x;

var
  bTerminated: boolean;
  Buffer: array[0..15] of char;

procedure PollThreadCreate;
begin
  hPollThread:=CreateThread(nil,0,@PollThread,nil,0,PollThreadID);
end;

procedure PollThreadTerminate;
begin
  bTerminated:=true;
end;

procedure PollThreadWaitFor;
var exitcode: cardinal;
begin
  while GetExitCodeThread(hPollThread,exitcode) do
    if exitcode <> STILL_ACTIVE then break;
  CloseHandle(hPollThread);
  hPollThread:=0;
end;

function PollThread(par: cardinal): cardinal;
var
  ScanCode: integer;
begin
  result:=0;
  if not Init713x() then begin
    MessageBox(0,'Error initializing device!','ManliTV Remote control',MB_OK + MB_ICONERROR);
    exit;
  end;
  bTerminated:=false;
  ScanCode:=-1;
  while not bTerminated do begin
    ScanCode:=Poll713x();
    if ScanCode <> -1 then begin
      wvsprintf(Buffer,'%d',@ScanCode);
      CallBackProc(@Buffer,length(Buffer));
    end;
  end;
  Done713x();
end;

end.
