unit Main;

interface

uses
  Windows;

type
  PRemoteInfo = ^TRemoteInfo;
  TRemoteInfo = record
      Size: cardinal;
      Name: array[0..63] of char;
      Version: array[0..63] of char;
      Flags: cardinal;
    end;
  TPluginCallback = function(buf: PChar; size: cardinal): boolean; stdcall;

const
  RF_CALLBACK = 1;
  RF_TIMER = 2;
  RF_CONFIGUREDIALOG = $100;

function HWInit: boolean; stdcall;
function HWDeInit: boolean; stdcall;
function ConfigurationDialog: boolean; stdcall;
function GetRemoteInfo(RemoteInfo: PRemoteInfo): boolean; stdcall;
function SetCallback(Callback: TPluginCallback): boolean; stdcall;

var
  CallBackProc: TPluginCallback;

implementation

uses
  ComThrd,saa713x;

function HWInit: boolean; stdcall;
begin
  PollThreadCreate();
  result:=true;
end;

function HWDeInit: boolean; stdcall;
begin
  if hPollThread <> 0 then begin
    PollThreadTerminate();
    PollThreadWaitFor();
  end;
  result:=true;
end;

function ConfigurationDialog: boolean; stdcall;
begin
  MessageBox(0,'Nothing to configure :)','Information',MB_OK + MB_IconInformation);
//  RC_LowGpioPin := $08;
//  RC_HighGpioPin := $0c;
//  RC_ResetGpioPin := $0f;
//  RC_StatusGpioPin := $0e;
  result:=true;
end;

function GetRemoteInfo(RemoteInfo: PRemoteInfo): boolean; stdcall;
begin
  with RemoteInfo^ do begin
    Size:=SizeOf(RemoteInfo);
    Name:='ManliTV Remote control (WDM)';
    Version:='1.0';
    Flags:=RF_CALLBACK;
  end;
  result:=true;
end;

function SetCallBack(Callback: TPluginCallback): boolean; stdcall;
begin
  CallBackProc:=CallBack;
  result:=true;
end;

end.


